package cn.efunbox.manage.base.entity;

import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.base.enums.CmsUserSuperEnum;
import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

@ToString
@Entity
@DynamicInsert
@DynamicUpdate
@Data
@Table(name = "user")
public class User implements Serializable{

    @Id
    private String id;

    @Column(name = "user_name")
    private String userName;

    @Column(name = "nick_name")
    private String nickName;

    @JSONField(serialize=false)
    private String password;

    @Column(name = "is_super")
    private CmsUserSuperEnum isSuper;

    @Column(name = "dept_id")
    private Long deptId;

    @Column(name = "gmt_created")
    private String gmtCreated;

    @Column(name = "gmt_modified")
    private String gmtModified;

    private BaseStatusEnum status;
}
