package cn.efunbox.manage.base.repository;

import cn.efunbox.manage.base.entity.User;
import cn.efunbox.manage.base.enums.BaseStatusEnum;
import cn.efunbox.manage.common.data.BasicRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface UserRepository extends BasicRepository<User> {


    User findByUserNameAndStatus(String userName, BaseStatusEnum status);

    User findByIdAndStatus(String id, BaseStatusEnum normal);

    User findById(String id);

    @Modifying
    @Query("update User set status=:status where id  in(:ids)")
    int updateStatusByIds(@Param("ids") List<String> ids, @Param("status") BaseStatusEnum status);
}
