package cn.efunbox.manage.base.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class TimeUtil {

    private static final String DEFAULT_PATTERN = "yyyy-MM-dd";
    /**
     * 一天的毫秒数
     */
    private static long TIME_OF_ONE_DAY = 24 * 60 * 60 * 1000;

    public static Long getTimeDiffer(String date) throws ParseException {
        Date nowDate=new Date();
        DateFormat format=new SimpleDateFormat("yy-MM-dd hh:mm:ss");
        long from = format.parse(date).getTime();
        long to = nowDate.getTime();
        Long sconds = (to - from)/1000;
        int hours=(24*60*60);
        if((sconds-hours)>=0){
            return null;
        }else {
            Long xx=  hours-sconds;
            return xx;
        }

    }

    public static String format(Date date) {
        DateFormat format=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return format.format(date);

    }

    public static String formatMonthDay(String day) {
        DateFormat format=new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        try {
            date = format.parse(day);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        format = new SimpleDateFormat("MM.dd");
        return format.format(date);

    }

    public static String formatDay(Date date) {
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        return format.format(date);

    }

    /**
     * 将DATE类型转成String类型,pattern默认为yyyy-MM-dd
     *
     * @return
     */
    public static String getDateStr() {
        Date  date = new Date();
        SimpleDateFormat formater = new SimpleDateFormat(DEFAULT_PATTERN);
        return formater.format(date);
    }

    public static String getPreDateStr() {
        Date  date = new Date(System.currentTimeMillis() - TIME_OF_ONE_DAY);
        SimpleDateFormat formater = new SimpleDateFormat(DEFAULT_PATTERN);
        return formater.format(date);
    }

    public static String weekOne(){
        Calendar cal = Calendar.getInstance();
        int d = 0;
        if (cal.get(Calendar.DAY_OF_WEEK) == 1) {
            d = -6;
        } else {
            d = 2 - cal.get(Calendar.DAY_OF_WEEK);
        }
        cal.add(Calendar.DAY_OF_WEEK, d);

        return formatDay(cal.getTime());
    }


    public static String dayOfWeek(int day){
        Calendar cal = Calendar.getInstance();
        int d = 0;
        if (cal.get(Calendar.DAY_OF_WEEK) == 1) {
            d = -6;
        } else {
            d = 2 - cal.get(Calendar.DAY_OF_WEEK);
        }
        cal.add(Calendar.DAY_OF_WEEK, d);
        cal.add(Calendar.DATE,day);
        return formatDay(cal.getTime());
    }



    public static  void main(String[] arg0){
       /* String dateStr = getDateStr();
        String preDateStr = getPreDateStr();
        System.out.println(dateStr);
        System.out.println(preDateStr);*/

//        double v = Math.random() * 50 + 50;
//        System.out.println(v);
//
//        Random random = new Random();
//        double v1 = random.nextDouble() * 50 + 50;

        String date = weekOne();
        System.out.println(date);

    }
}
