package cn.efunbox.manage.base.controller;

import cn.efunbox.manage.base.entity.Product;
import cn.efunbox.manage.base.service.ProductService;
import cn.efunbox.manage.common.result.ApiResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * ProductController
 * Created by wangys on 2019/03/12
 */
@RestController
@RequestMapping("/product")
public class ProductController {

    @Autowired
    ProductService productService;

    @PostMapping
    public ApiResult save(@RequestBody Product product){
        return productService.save(product);
    }

    @PutMapping
    public ApiResult update(@RequestBody Product product){
        return productService.update(product);
    }

    @GetMapping
    public ApiResult list(Product product){
        return productService.list(product);
    }

    @GetMapping("/{id}")
    public ApiResult findById(@PathVariable(name = "id") Long productId){
        return productService.getProductById(productId);
    }

    @GetMapping("/select")
    public ApiResult select(){
        return productService.getSelect();
    }

}
