package cn.efunbox.manage.base.controller;

import cn.efunbox.manage.base.entity.User;
import cn.efunbox.manage.base.service.UserService;
import cn.efunbox.manage.common.entity.page.OnePage;
import cn.efunbox.manage.common.result.ApiResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * UserController
 * Created by xusq on 2018/6/4.
 */
@Slf4j
@RestController
@RequestMapping("/user")
public class UserController {


    @Autowired
    UserService userService;

    @GetMapping("/list")
    public ApiResult<OnePage<User>> listForCms(User user, Integer pageNo, Integer pageSize){

        return userService.list(user, pageNo, pageSize);

    }

    @PostMapping()
    public ApiResult save(User user){
        return userService.saveUser(user);

    }
    @PutMapping()
    public ApiResult update(User user){
        return userService.updateUser(user);

    }
    @DeleteMapping()
    public ApiResult delete(String userId){
        List<String> ids = new ArrayList<>();
        ids.add(userId);
        return userService.deleteUserByIds(ids);

    }
}
